<template>
  <div class="pagination">
    <app-button :disabled="isFirstPage" :is-link="true" @button-click="paginationPerNumber(1)"> &lt;&lt; First page </app-button>
    <app-button :disabled="isFirstPage" :is-link="true" @button-click="paginationPrev()"> &lt; Previous </app-button>
    <span> - </span><span class="pagination__current"> {{ pagination.page }} </span><span> - </span>
    <app-button :disabled="isLastPage" :is-link="true" @button-click="paginationNext()">Next &gt;</app-button>
    <app-button :disabled="isLastPage" :is-link="true" @button-click="paginationPerNumber(pagination.lastPage)"> Last page &gt;&gt; </app-button>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapActions, mapState } from 'vuex';
import { AppMode } from '@/types';

// Components
import AppButton from '@/components/AppButton.vue';

declare module 'vue/types/vue' {
  interface Vue {
    getCharacters: (pagination: any) => void;
    setPagination: (pagination: any) => void;
  }
}

export default Vue.extend({
  name: 'DataTablePagination',

  components: {
    AppButton
  },

  computed: {
    ...mapState({
      appMode: (state: any) => state.global.appMode,
      pagination: (state: any) => state.characters.pagination
    }),

    isFirstPage () {
      return this.pagination.page === 1;
    },

    isLastPage () {
      return this.pagination.page === this.pagination.lastPage;
    },

    nextPageNumber () {
      return this.pagination.page + 1;
    },

    prevPageNumber () {
      return this.pagination.page - 1;
    }
  },

  methods: {
    ...mapActions([
      'getCharacters',
      'setPagination'
    ]),

    paginationNext (): void {
      if (this.appMode === AppMode.live) {
        this.getCharacters({ page: this.nextPageNumber });
      } else {
        this.setPagination({ page: this.nextPageNumber });
      }
    },

    paginationPerNumber (pageNumber: number): void {
      if (this.appMode === AppMode.live) {
        this.getCharacters({ page: pageNumber });
      } else {
        this.setPagination({ page: pageNumber });
      }
    },

    paginationPrev (): void {
      if (this.appMode === AppMode.live) {
        this.getCharacters({ page: this.prevPageNumber });
      } else {
        this.setPagination({ page: this.prevPageNumber });
      }
    }
  }
});
</script>

<style lang="scss" scoped>
.pagination {
  display: flex;
  justify-content: center;
  align-items: center;
  margin-top: 2rem;

  &__current {
    margin: 0 .5rem;
    font-weight: 600;
  }
}

</style>
